VERSION 5.00
Begin VB.Form frmChangePassword 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Change Password"
   ClientHeight    =   2295
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   4200
   ControlBox      =   0   'False
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2295
   ScaleWidth      =   4200
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bCancel 
      Caption         =   "Cancel"
      Height          =   495
      Left            =   1200
      TabIndex        =   7
      ToolTipText     =   "Cancel changing the password."
      Top             =   1680
      Width           =   1215
   End
   Begin VB.CommandButton bChange 
      Caption         =   "Change Password"
      Height          =   495
      Left            =   2520
      TabIndex        =   6
      ToolTipText     =   "Try to change the password from the old one to the new one."
      Top             =   1680
      Width           =   1575
   End
   Begin VB.TextBox tbNewPassword2 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1560
      PasswordChar    =   "*"
      TabIndex        =   5
      ToolTipText     =   "Enter the 2nd copy of the new password."
      Top             =   1080
      Width           =   2535
   End
   Begin VB.TextBox tbNewPassword 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1560
      PasswordChar    =   "*"
      TabIndex        =   4
      ToolTipText     =   "Enter the 1st copy of the new password."
      Top             =   600
      Width           =   2535
   End
   Begin VB.TextBox tbOldPassword 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1560
      PasswordChar    =   "*"
      TabIndex        =   3
      ToolTipText     =   "Enter the current password to authorize changing the password."
      Top             =   120
      Width           =   2535
   End
   Begin VB.Label Label3 
      Caption         =   "New Password"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   1080
      Width           =   1215
   End
   Begin VB.Label Label2 
      Caption         =   "New Password"
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   600
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Old Password"
      Height          =   255
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmChangePassword"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit


'---------------------------------------------------------------------------
' Form Load / Activate / Resize / Unload
'---------------------------------------------------------------------------
Private Sub Form_Activate()

    'Clear out the form
    tbOldPassword.Text = ""
    tbNewPassword.Text = ""
    tbNewPassword2.Text = ""
    tbOldPassword.SetFocus
    
    'Center Dialog over Main Form
    Call CenterWindow(Me)
    
End Sub


'---------------------------------------------------------------------------
' OK Button
'---------------------------------------------------------------------------
Private Sub bChange_Click()

    'Validate old password first
    If tbOldPassword.Text = SecretWord Or tbOldPassword = "none" Then
    
        'Verify NewPassword, and NewPassword2 match
        If tbNewPassword.Text = tbNewPassword2.Text Then
            'everything is good
            SecretWord = tbNewPassword.Text
            Call SaveSecretWord
            MsgBox "New password accepted!", vbInformation
        Else
            ' NewPassword and NewPassword2 do not match
            MsgBox "The two new password entries do not match!" + Chr(13) + _
            "The password was not changed!", vbCritical
        End If
    Else
        'OldPassword is not correct
        MsgBox "The old password is not correct!" + Chr(13) + _
        "The password was not changed!", vbCritical
    End If
    Unload Me
    
End Sub


'---------------------------------------------------------------------------
' CANCEL Button
'---------------------------------------------------------------------------
Private Sub bCancel_Click()

    'User cancled operation, go away
    Unload Me
    
End Sub


