VERSION 5.00
Begin VB.Form frmConfigTlus 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Configure Counters"
   ClientHeight    =   3375
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8025
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   3375
   ScaleWidth      =   8025
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox tHostName 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1560
      TabIndex        =   4
      Text            =   "tHostName"
      ToolTipText     =   "Enter the host name or IP address of this PPT."
      Top             =   1800
      Width           =   6375
   End
   Begin VB.CommandButton bCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3720
      TabIndex        =   9
      ToolTipText     =   "Cancel adjustments to the PPT configuration."
      Top             =   2760
      Width           =   1335
   End
   Begin VB.ComboBox cTlu 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   0
      ToolTipText     =   "Select a PPT to adjust."
      Top             =   120
      Width           =   6375
   End
   Begin VB.ComboBox cSchedule 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   5
      ToolTipText     =   "Select a schedule for this PPT."
      Top             =   2280
      Width           =   6375
   End
   Begin VB.CommandButton bApply 
      Caption         =   "Apply"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5160
      TabIndex        =   8
      ToolTipText     =   "Apply adjustments to the PPT configuration."
      Top             =   2760
      Width           =   1335
   End
   Begin VB.CommandButton bOK 
      Caption         =   "OK"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   6600
      TabIndex        =   6
      ToolTipText     =   "Apply adjustments to the PPT configuration and close this dialog."
      Top             =   2760
      Width           =   1335
   End
   Begin VB.ComboBox cAddress 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   3
      ToolTipText     =   "Select the address of this PPT."
      Top             =   1800
      Width           =   6375
   End
   Begin VB.ComboBox cPort 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1560
      Style           =   2  'Dropdown List
      TabIndex        =   2
      ToolTipText     =   "Select the port used to communicate with this PPT."
      Top             =   1320
      Width           =   6375
   End
   Begin VB.TextBox tName 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   525
      Left            =   1560
      TabIndex        =   1
      Text            =   "tName - Unit Name"
      ToolTipText     =   "Enter a name for this PPT."
      Top             =   600
      Width           =   6375
   End
   Begin VB.Label lHostName 
      Caption         =   "Host Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label Label5 
      Caption         =   "Schedule:"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   2280
      Width           =   1215
   End
   Begin VB.Label lAddress 
      Caption         =   "Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label lPort 
      Caption         =   " Port:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label lPPTName 
      Caption         =   "Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   720
      Width           =   1215
   End
   Begin VB.Label lTlu 
      Caption         =   "Counter:"
      Height          =   255
      Left            =   120
      TabIndex        =   7
      Top             =   120
      Width           =   1215
   End
End
Attribute VB_Name = "frmConfigTlus"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

'Declare Trimline Configuration Type
Private Type TLUCONFIGTYPE
    Name As String          'Trimline Symbolic Name
    Port As Integer         'Comport 1 to 16 (0 = disabled)
    Address As Integer      'Address character 32 to 126
    HostName As String      'TCP/IP Host Name
    Schedule As Integer     'Schedule Selection 1 to 64
End Type

'Local Config Storage
Dim Config(1 To NUMTLU) As TLUCONFIGTYPE


'---------------------------------------------------------------------------
' Form Load / Activate / Resize / Unload
'---------------------------------------------------------------------------
Private Sub Form_Load()
    Dim i As Integer
    
    'Restore form to proper position and size
    Call LoadWindowPosition(Me)
    
    'make a local copy of the Trimline configuation data
    For i = LBound(Config) To UBound(Config)
        Config(i).Name = Tlu(i).Name
        Config(i).Port = Tlu(i).Port
        Config(i).Address = Tlu(i).Address
        Config(i).HostName = Tlu(i).HostName
        Config(i).Schedule = Tlu(i).Schedule
    Next i
    
    'Program the Trimline Selection Combo
    For i = LBound(Config) To UBound(Config)
        cTlu.AddItem "#" & Format(i, "#) ") & Config(i).Name
    Next i
    
    'Program the Port Selection Combo
    For i = 0 To 16
        cPort.AddItem fmtPort(i)
    Next i
    
    'Program the Address Selection Combo
    cAddress.AddItem fmtAddr(0)
    cAddress.ItemData(cAddress.NewIndex) = 0
    For i = 33 To 126
        cAddress.AddItem fmtAddr(i)
        cAddress.ItemData(cAddress.NewIndex) = i
    Next i
    
    'Program the Schedule Selection Combo
    For i = 0 To UBound(Schedule)
        cSchedule.AddItem fmtSchedule(i)
    Next i
    
    'Select the 1st Trimline
    cTlu.ListIndex = 0
    
End Sub


Private Sub Form_Unload(Cancel As Integer)

    'Save form position and size
    Call SaveWindowPosition(Me)

End Sub


'---------------------------------------------------------------------------
' The User Selected a Trimline, Load the Form
'---------------------------------------------------------------------------
Private Sub cTlu_Click()
    Dim Unit As Integer
    
    'Identify the Selected Trimline
    Unit = cTlu.ListIndex + 1
    
    'Populate the form with the selected Trimline Config
    tName = Config(Unit).Name
    cPort.ListIndex = Config(Unit).Port
    If Config(Unit).Address > 32 And Config(Unit).Address < 127 Then
        cAddress.ListIndex = Config(Unit).Address - 32
    Else
        cAddress.ListIndex = 0
    End If
    tHostName = Config(Unit).HostName
    cSchedule.ListIndex = Config(Unit).Schedule
    
End Sub



'---------------------------------------------------------------------------
' As the User Edits the Trimline, Keep the Config() Array in Sync
'---------------------------------------------------------------------------
'User Edited the Trimline Name
Private Sub tName_Change()
    Config(cTlu.ListIndex + 1).Name = tName
    cTlu.List(cTlu.ListIndex) = "#" & Format(cTlu.ListIndex + 1, "0) ") & Config(cTlu.ListIndex + 1).Name
End Sub

'User Editied the Port Selection
Private Sub cPort_Click()
    Config(cTlu.ListIndex + 1).Port = cPort.ListIndex
    If (cPort.ListIndex = 16) Then
        lAddress.Visible = False
        cAddress.Visible = False
        lHostName.Visible = True
        tHostName.Visible = True
    Else
        lAddress.Visible = True
        cAddress.Visible = True
        lHostName.Visible = False
        tHostName.Visible = False
    End If
End Sub

'User Edited the Address Selection
Private Sub cAddress_Click()
    Config(cTlu.ListIndex + 1).Address = cAddress.ItemData(cAddress.ListIndex)
End Sub

'User Edited the HostName
Private Sub thostName_Change()
    Config(cTlu.ListIndex + 1).HostName = tHostName
End Sub

'User Edited the Schedule Selection
Private Sub cSchedule_Click()
    Config(cTlu.ListIndex + 1).Schedule = cSchedule.ListIndex
End Sub


'---------------------------------------------------------------------------
' OK and Cancel Buttons
'---------------------------------------------------------------------------
Private Sub bOK_Click()
    
    'Password Protected Operation
    If (CheckPassword(Me) = True) Then
    
        'Apply Changes and then go away
        Call ApplyChanges
        Unload Me
    
    End If
    
End Sub


Private Sub bApply_Click()

    'Password Protected Operation
    If (CheckPassword(Me) = True) Then
    
        'Apply Changes
        Call ApplyChanges
    
    End If

End Sub


Private Sub bCancel_Click()
    
    'User selected cancel
    Unload Me
    
End Sub

Public Sub ApplyChanges()
    Dim i As Integer

    For i = LBound(Tlu) To UBound(Tlu)
        
        'Don't allow blank names
        If Len(Config(i).Name) = 0 Then
            Config(i).Name = "UNIT" + Str(i) 'default name
        End If
        
        'if either port or address are "(none)" force defaults
        If (Config(i).Port = 0 Or (Config(i).Address = 0 And Config(i).Port <> 16)) Then
        
            'Mark this Trimline as **UNUSED**
            Tlu(i).Name = "UNIT" + Str(i)
            Tlu(i).Port = 0
            Tlu(i).Address = 0
            Tlu(i).HostName = "(none)"
            Tlu(i).Schedule = 0
        
        Else
            
            'update the Tlu() config structure
            Tlu(i).Name = Config(i).Name
            Tlu(i).Port = Config(i).Port
            Tlu(i).Address = Config(i).Address
            Tlu(i).HostName = Config(i).HostName
            Tlu(i).Schedule = Config(i).Schedule
        
        End If
        
        
    Next i
    
    'Now update mass storage with the new values
    Call SaveAllConfiguration
    
End Sub
