VERSION 5.00
Begin VB.Form frmConfigTotalizers 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Configure Totalizers"
   ClientHeight    =   5520
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   8295
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   5520
   ScaleWidth      =   8295
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cActualAddress 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1800
      Style           =   2  'Dropdown List
      TabIndex        =   4
      ToolTipText     =   "Select the address of the total actual display field."
      Top             =   2280
      Width           =   6375
   End
   Begin VB.ComboBox cTotalizer 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1800
      Style           =   2  'Dropdown List
      TabIndex        =   0
      ToolTipText     =   "Select a Totalizer to adjust."
      Top             =   120
      Width           =   6375
   End
   Begin VB.TextBox tHostName 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1800
      TabIndex        =   3
      Text            =   "tHostName"
      ToolTipText     =   "Enter the host name or IP address of this totalizer display."
      Top             =   1800
      Width           =   6375
   End
   Begin VB.CommandButton bApply 
      Caption         =   "Apply"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   5400
      TabIndex        =   8
      ToolTipText     =   "Apply adjustments to totalizer configuration."
      Top             =   4920
      Width           =   1335
   End
   Begin VB.ListBox lTlu 
      Columns         =   2
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   1950
      Left            =   1800
      Style           =   1  'Checkbox
      TabIndex        =   5
      ToolTipText     =   "Select which PPTs are included in the total calculations."
      Top             =   2760
      Width           =   6375
   End
   Begin VB.CommandButton bCancel 
      Caption         =   "Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   3960
      TabIndex        =   9
      ToolTipText     =   "Cancel adjustments to totalizer configuration."
      Top             =   4920
      Width           =   1335
   End
   Begin VB.CommandButton bOK 
      Caption         =   "OK"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   495
      Left            =   6840
      TabIndex        =   7
      ToolTipText     =   "Apply adjustments to totalizer configuration and close the dialog."
      Top             =   4920
      Width           =   1335
   End
   Begin VB.ComboBox cPort 
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   9.75
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   360
      Left            =   1800
      Style           =   2  'Dropdown List
      TabIndex        =   2
      ToolTipText     =   "Select the port that is used to communicate with this totalizer display."
      Top             =   1320
      Width           =   6375
   End
   Begin VB.TextBox tName 
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   18
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   525
      Left            =   1800
      TabIndex        =   1
      Text            =   "tName - PPT Name"
      ToolTipText     =   "Enter a name for this totalizer display."
      Top             =   600
      Width           =   6375
   End
   Begin VB.Label lActualAddress 
      Caption         =   "Actual Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   15
      Top             =   2280
      Width           =   1455
   End
   Begin VB.Label lHostName 
      Caption         =   "Host Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   14
      Top             =   1800
      Width           =   1455
   End
   Begin VB.Label lTotalizerFor 
      Caption         =   "Totalizer for:"
      Height          =   255
      Left            =   120
      TabIndex        =   13
      Top             =   2760
      Width           =   1455
   End
   Begin VB.Label lAddress 
      Caption         =   "Address:"
      Height          =   255
      Left            =   120
      TabIndex        =   12
      Top             =   1800
      Width           =   1215
   End
   Begin VB.Label lPort 
      Caption         =   "Port:"
      Height          =   255
      Left            =   120
      TabIndex        =   11
      Top             =   1320
      Width           =   1455
   End
   Begin VB.Label lName 
      Caption         =   "Name:"
      Height          =   255
      Left            =   120
      TabIndex        =   10
      Top             =   720
      Width           =   1455
   End
   Begin VB.Label lTotalizer 
      Caption         =   "Totalizer Display:"
      Height          =   255
      Left            =   120
      TabIndex        =   6
      Top             =   120
      Width           =   1455
   End
End
Attribute VB_Name = "frmConfigTotalizers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit

'Declare Totalizer Configuration Type
Private Type TOTALIZERCONFIGTYPE
    Name As String                          'Symbolic Name of this Totalizer
    Port As Integer                         'Comport 1 to 16 (0 = disabled)
    HostName As String                      'TCP/IP Host Name
    ActualAddress As Integer                'Address Character 32 to 126
    TluIsMember(1 To NUMTLU) As Integer     'Is this Trimline a used in the Calculation
End Type

'Local Config Storage
Dim Config(1 To NUMTOTALIZER) As TOTALIZERCONFIGTYPE


'---------------------------------------------------------------------------
' Form Load / Activate / Resize / Unload
'---------------------------------------------------------------------------
Private Sub Form_Load()
    Dim Unit As Integer
    Dim i As Integer
    
    'Restore form to proper position and size
    Call LoadWindowPosition(Me)
    
    'make a local copy of the totalizer display configuation data
    For Unit = LBound(Totalizer) To UBound(Totalizer)
        Config(Unit).Name = Totalizer(Unit).Name
        Config(Unit).Port = Totalizer(Unit).Port
        Config(Unit).HostName = Totalizer(Unit).HostName
        Config(Unit).ActualAddress = Totalizer(Unit).ActualAddress
        For i = LBound(Tlu) To UBound(Tlu)
            Config(Unit).TluIsMember(i) = Totalizer(Unit).TluIsMember(i)
        Next i
    Next Unit
    
    'Program the Totalizer Selection Combo
    For i = LBound(Config) To UBound(Config)
        cTotalizer.AddItem "#" & Format(i, "#) ") & Config(i).Name
    Next i
    
    'Program the Port Selection Combo
    For i = 0 To 16
        cPort.AddItem fmtPort(i)
    Next i
    
    'Program the Address Selection Combos
    cActualAddress.AddItem fmtAddr(0)
    cActualAddress.ItemData(cActualAddress.NewIndex) = 0
    For i = 33 To 126
        cActualAddress.AddItem fmtAddr(i)
        cActualAddress.ItemData(cActualAddress.NewIndex) = i
    Next i
    
    'Load the Trimline Selection List
    For i = LBound(Tlu) To UBound(Tlu)
        lTlu.AddItem Tlu(i).Name
    Next i
    
    'Select the 1st Totalizer Display
    cTotalizer.ListIndex = 0
    
End Sub


Private Sub Form_Unload(Cancel As Integer)

    'Save form position and size
    Call SaveWindowPosition(Me)

End Sub


'---------------------------------------------------------------------------
' The User Selected a Totalizer, Load the Form
'---------------------------------------------------------------------------
Private Sub cTotalizer_Click()
    Dim Unit As Integer
    Dim i As Integer
    
    'Identify the Selected Totalizer
    Unit = cTotalizer.ListIndex + 1
    
    'Populate the Totalizer Name
    tName = Config(Unit).Name
    
    'Populate the Totalizer Port Selection
    cPort.ListIndex = Config(Unit).Port
    
    'Populate the Totalizer Host Name
    tHostName = Config(Unit).HostName
    
    'Populate the Totalizer Actual Address Selection
    If Config(Unit).ActualAddress > 32 And Config(Unit).ActualAddress < 127 Then
        cActualAddress.ListIndex = Config(Unit).ActualAddress - 32
    Else
        cActualAddress.ListIndex = 0
    End If
    
    'Populate the Trimline List
    Call LoadTluList
    
End Sub


'---------------------------------------------------------------------------
' As the User Edits the Totalizer, Keep the Config() Array in Sync
'---------------------------------------------------------------------------
'User Edited the Totalizer Name
Private Sub tName_Change()
    Config(cTotalizer.ListIndex + 1).Name = tName
    cTotalizer.List(cTotalizer.ListIndex) = "#" & Format(cTotalizer.ListIndex + 1, "0) ") & Config(cTotalizer.ListIndex + 1).Name
End Sub

'User Editied the Port Selection
Private Sub cPort_Click()
    Config(cTotalizer.ListIndex + 1).Port = cPort.ListIndex
    If (cPort.ListIndex = 16) Then
        lHostName.Enabled = True
        tHostName.Enabled = True
    Else
        lHostName.Enabled = False
        tHostName.Enabled = False
    End If
End Sub

'User Edited the HostName
Private Sub thostName_Change()
    Config(cTotalizer.ListIndex + 1).HostName = tHostName
End Sub

'User Edited the Actual Address Selection
Private Sub cActualAddress_Click()
    Config(cTotalizer.ListIndex + 1).ActualAddress = cActualAddress.ItemData(cActualAddress.ListIndex)
End Sub

'User Editied the Member Trimline Selection
Private Sub lTlu_Click()
    Dim Unit As Integer
    Dim i As Integer
    
    Unit = cTotalizer.ListIndex + 1
    i = lTlu.ListIndex + 1
    Config(Unit).TluIsMember(i) = lTlu.Selected(i - 1)
    
End Sub

'Load the Trimline List for the Current Unit
Public Sub LoadTluList()
    Dim Unit As Integer
    Dim i As Integer
    
    Unit = cTotalizer.ListIndex + 1
    lTlu.Clear
    For i = LBound(Config(Unit).TluIsMember) To UBound(Config(Unit).TluIsMember)
        Call lTlu.AddItem("#" & i & ")" & Tlu(i).Name)
        lTlu.Selected(i - 1) = Config(Unit).TluIsMember(i)
    Next i

End Sub


'---------------------------------------------------------------------------
' OK, Apply, and Cancel Buttons
'---------------------------------------------------------------------------
Private Sub bOK_Click()

    'Password Protected Operation
    If (CheckPassword(Me) = True) Then
    
        Call ApplyChanges
        Unload Me
        
    End If
    
End Sub


Private Sub bApply_Click()

    'Password Protected Operation
    If (CheckPassword(Me) = True) Then
    
        Call ApplyChanges
        
    End If

End Sub


Private Sub bCancel_Click()
    
    'User selected cancel
    Unload Me
    
End Sub

Public Sub ApplyChanges()
    Dim Unit As Integer
    Dim i As Integer

    For Unit = LBound(Totalizer) To UBound(Totalizer)
        
        'Don't allow blank names
        If Len(Config(Unit).Name) = 0 Then
            Config(Unit).Name = "Totalizer" + Str(Unit) 'default name
        End If
        
        'if port is "(none)" force defaults
        If (Config(Unit).Port = 0) Then
        
            'Mark this Totalizer as **UNUSED**
            Totalizer(Unit).Name = "Totalizer" + Str(Unit)
            Totalizer(Unit).Port = 0
            Totalizer(Unit).HostName = "(none)"
            Totalizer(Unit).ActualAddress = 0
            Totalizer(Unit).Status = "(none)"
            For i = LBound(Totalizer(Unit).TluIsMember) To UBound(Totalizer(Unit).TluIsMember)
                Totalizer(Unit).TluIsMember(i) = 0
            Next i
        Else
            
            'update the Totalizer() config structure
            Totalizer(Unit).Name = Config(Unit).Name
            Totalizer(Unit).Port = Config(Unit).Port
            Totalizer(Unit).HostName = Config(Unit).HostName
            Totalizer(Unit).ActualAddress = Config(Unit).ActualAddress
            For i = LBound(Totalizer(Unit).TluIsMember) To UBound(Totalizer(Unit).TluIsMember)
                Totalizer(Unit).TluIsMember(i) = Config(Unit).TluIsMember(i)
            Next i
        
        End If
        
    Next Unit
    
    'Now update mass storage with the new values
    Call SaveAllConfiguration
        
End Sub
