VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "MSFLXGRD.OCX"
Begin VB.Form frmTotalizers 
   Caption         =   "Totalizers"
   ClientHeight    =   3090
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   12030
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   12030
   StartUpPosition =   3  'Windows Default
   Begin MSFlexGridLib.MSFlexGrid Grid1 
      Height          =   2415
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   3015
      _ExtentX        =   5318
      _ExtentY        =   4260
      _Version        =   393216
   End
End
Attribute VB_Name = "frmTotalizers"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit


'---------------------------------------------------------------------------
' Form Load / Activate / Resize / Unload
'---------------------------------------------------------------------------
Private Sub Form_Load()
    
    'Restore form to proper position and size
    Call LoadWindowPosition(Me)
    
    'Initialize the grid display style
    Grid1.HighLight = flexHighlightNever            'Turn off cell highlighting
    Grid1.ScrollTrack = True                        'Enable ScrollTracking
    Grid1.Cols = 3                                  'Set Table Width
    Grid1.Rows = 65                                 'Set Table Height
    Grid1.ColWidth(0) = (Grid1.ColWidth(0) * 3)     'Make the Name Column Triple Width
    Grid1.ColWidth(1) = (Grid1.ColWidth(1) * 3)     'Make the Name Column Triple Width
    Grid1.ColWidth(2) = (Grid1.ColWidth(2) * 3)     'Make the Status Column Triple Width
    Grid1.FillStyle = flexFillRepeat                'settings apply to table selections
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.RowSel = Grid1.Rows - 1                   'select all of the first column
    Grid1.ColSel = Grid1.Cols - 1                   'select the entire table
    Grid1.CellAlignment = flexAlignCenterCenter     'Center Text in the Cell
    Grid1.Col = 0: Grid1.Row = 0                    'select top left cell
    Grid1.ColSel = Grid1.Cols - 1                   'select the top row
    Grid1.CellFontBold = True                       'set text to BOLD
    
    'Set the Grid Column Labels Text
    Grid1.TextArray(0) = "Totalizer Name"
    Grid1.TextArray(1) = "Total Actual"
    Grid1.TextArray(2) = "Status"
    
    'put the curssor in the upper left corner
    Grid1.Col = 1
    Grid1.Row = 1
    
End Sub


Private Sub Form_Resize()

    'auto resize the flexgrid to fill the form at run time
    Grid1.Top = 0
    Grid1.Left = 0
    Grid1.Width = Me.ScaleWidth
    Grid1.Height = Me.ScaleHeight
    
End Sub


Private Sub Form_Unload(Cancel As Integer)
    
    'Save form position and size
    Call SaveWindowPosition(Me)
    
End Sub


'---------------------------------------------------------------------------
' Pace Timer Data MSFlexGrid
'---------------------------------------------------------------------------
Private Sub Grid1_Click()
    Dim Unit As Integer
    Dim Register As Integer
    
    'Get the Row and Column clicked on
    Unit = Grid1.MouseRow
    Register = Grid1.MouseCol
    
    If (Unit >= 1) Then
    
        'Use selected a Totalizer Detailed View, bring it up
        'frmTotalizerDetail.Tag = Unit
        'frmTotalizerDetail.Show
        
    End If
    
End Sub


Private Sub Grid1_KeyPress(KeyAscii As Integer)

    'filter keypresses in the grid
    If KeyAscii = Asc(vbCr) Then
        KeyAscii = 0
        Call Grid1_Click
    End If

End Sub


'---------------------------------------------------------------------------
' This function is called by BackgroundFunction() when updated
' Totalizer(Unit) Data is available, and the Screen needs to be redrawn
'---------------------------------------------------------------------------
Public Sub UpdateData(Unit As Integer)
    Dim RowLen As Integer
    Dim RowStart As Integer
    Dim Text As String
    
    'Get the number of cells per row
    'for calculating the textarray index
    RowLen = Grid1.Cols
    
    'Calculate the TextArray Index for the
    'Start of this row
    RowStart = Unit * RowLen
        
    'update this grid row
    With Totalizer(Unit)
        Grid1.TextArray(RowStart + 0) = .Name
        Grid1.TextArray(RowStart + 1) = fmtNumber(.TotalActual)
        Grid1.TextArray(RowStart + 2) = .Status
    End With
                
End Sub


