VERSION 5.00
Begin VB.Form frmWriteReg 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "frmWriteReg"
   ClientHeight    =   2490
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   6390
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2490
   ScaleWidth      =   6390
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton bAccept 
      Caption         =   "&OK"
      Default         =   -1  'True
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3240
      TabIndex        =   3
      ToolTipText     =   "Click here to accept the change."
      Top             =   1920
      Width           =   3015
   End
   Begin VB.CommandButton bCancel 
      Cancel          =   -1  'True
      Caption         =   "&Cancel"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   2
      ToolTipText     =   "Click here to cancel change."
      Top             =   1920
      Width           =   3015
   End
   Begin VB.TextBox tNewVal 
      Alignment       =   2  'Center
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3240
      TabIndex        =   1
      ToolTipText     =   "Enter the new register value here."
      Top             =   1320
      Width           =   3015
   End
   Begin VB.Label lNew 
      Alignment       =   1  'Right Justify
      Caption         =   "New Reg:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   6
      Top             =   1320
      Width           =   2895
   End
   Begin VB.Label lCurrentVal 
      Alignment       =   2  'Center
      Caption         =   "000000"
      BeginProperty Font 
         Name            =   "Courier New"
         Size            =   14.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   3240
      TabIndex        =   5
      ToolTipText     =   "This is the current register value."
      Top             =   720
      Width           =   2895
   End
   Begin VB.Label lCurrent 
      Alignment       =   1  'Right Justify
      Caption         =   "Current Reg:"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   4
      Top             =   720
      Width           =   2895
   End
   Begin VB.Label lTitle 
      Alignment       =   2  'Center
      Caption         =   "Change Register"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   13.5
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   450
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6135
   End
End
Attribute VB_Name = "frmWriteReg"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'---------------------------------------------------------------------------
' This program was developed on a Win2K system using Visual Basic 6.0 for
' windows. The program source and binaries are distributed under a BSD
' Style License.
'
' Developed By:
' Matthew T. Linehan
' American LED-gible Inc.
' Phone: 614.851.1100
' email: engineering@ledgible.com
'
' Copyright (C) 2011, American LED-Gible Inc. All rights reserved.
' Redistribution and use in source and binary forms, with or without
' modification, are permitted provided that the following conditions are met:
'
' Redistributions of source code must retain the above copyright notice, this
' list of conditions, and the following disclaimer. Redistributions in binary
' form must reproduce the above copyright notice, this list of conditions and
' the following disclaimer in the documentation and/or other materials provided
' with the distribution.
'
' THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
' IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
' ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
' LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
' CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
' SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
' INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
' CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
' ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
' POSSIBILITY OF SUCH DAMAGE.
'---------------------------------------------------------------------------
Option Explicit


'---------------------------------------------------------------------------
' Form Load / Activate / Resize / Unload
'---------------------------------------------------------------------------
Private Sub Form_Load()
    
    'Restore form to proper position
    Call LoadWindowPosition(Me)

End Sub

Private Sub Form_Activate()
    
    'We were just activated, force an update
    Call UpdateDetailData
    
End Sub


Private Sub Form_Unload(Cancel As Integer)

    'Save form position
    Call SaveWindowPosition(Me)

End Sub


'---------------------------------------------------------------------------
' OK and Cancel Buttons...
'---------------------------------------------------------------------------
Private Sub bAccept_Click()
    
    'User Accepted the Edit Initiate the write
    Dim Cmd As String
    Dim Unit As Integer
    Unit = Val(Me.Tag)
    
    'Password Protected Operation
    If (CheckPassword(Me) = True) Then
    
        'Write Actual
        If InStr(Me.Tag, "AC") <> 0 Then
            Cmd = "WAC" & RegVal6Digit(Me.tNewVal.Text)
            Call Tlu(Unit).CmdQueue.Enqueue(Cmd)
        End If
        
        'Go Away
        Unload Me
    
    End If
    
End Sub


Private Sub bCancel_Click()
    
    'User Canceled the update
    'go away
    Unload Me
    
End Sub


'---------------------------------------------------------------------------
' This function is called by BackgroundFunction() when updated
' Tlu(Unit) Data is available, and the Screen needs to be redrawn
'---------------------------------------------------------------------------
Public Sub UpdateData(Unit As Integer)
    
    'UpdateTluForms calles this sub to tell us
    'Updated data is available in the Tlu() structure
    'if the updated unit is the one were showing
    'we need to update ourselves
    If Unit = Val(Me.Tag) Then Call UpdateDetailData
    
End Sub


Private Sub UpdateDetailData()
    
    'Here is where we do the work of keeping all the
    'controls on the form up to date with Tlu() data
    'Me.Tag contains the Unit/RegID were working with
    Dim Unit As Integer
    Unit = Val(Me.Tag)
    
    'Updates for Change Actual Dialog
    If InStr(Me.Tag, "AC") <> 0 Then
        Me.Caption = "Change Actual - " + Tlu(Unit).Name
        Me.lTitle = Me.Caption
        Me.lCurrent = "Current Actual:"
        Me.lNew = "New Actual:"
        Me.lCurrentVal = fmtNumber(Tlu(Unit).Actual.Value)
        Me.tNewVal.MaxLength = 6
    End If
    
End Sub



